﻿--Versioning information
local BMR_VERSION = "6.0";

local timesShown = 0;
local ShowingRollList = 0;
local bmrRolls;
local bmrRollers;
local bmrItem = nil;

--Ulduar totals
local UldFlameLeviathan = 0;
local UldRazorscale     = 0;
local UldIgnis          = 0;
local UldXT             = 0;
local UldAssembly       = 0;
local UldKologarn       = 0;
local UldAuriaya        = 0;
local UldHodir          = 0;
local UldThorim         = 0;
local UldFreya          = 0;
local UldMimiron        = 0;
local UldGeneralVezax   = 0;
local UldYoggSaron      = 0;
local UldAlgalon        = 0;
local UldTotalKills     = 0;

--Call of the Crusade Totals
local CotCBeasts        = 0;
local CotCLordJaraxxus  = 0;
local CotCFactionChamp  = 0;
local CotCValkyrTwins   = 0;
local CotCTimesComplete = 0;
local CotCTotalKills    = 0;

--Fall of the Lich King Totals (Icecrown)
local ICCLichKing       = 0;    
local ICCSindragosa     = 0;
local ICCBloodQueen     = 0;
local ICCPutricide      = 0;
local ICCValithria      = 0;
local ICCBloodCouncil   = 0;
local ICCRotface        = 0;
local ICCFestergut      = 0;
local ICCDeathbringer   = 0;
local ICCGunship        = 0;
local ICCDeathwhisper   = 0;
local ICCMarrowgar      = 0;
local ICCTotalKills     = 0;

--Checking other value
local bCheckingTotals = 0;

function ifnil(value, default)
  if (value == nil) then
    return default;
  else
    return value;
  end;
end


function BMR_GetUldTotals()
  UldFlameLeviathan = GetStatistic(2872); if (UldFlameLeviathan == nil or UldFlameLeviathan == "--") then UldFlameLeviathan = 0; end;
  UldRazorscale     = GetStatistic(2873); if (UldRazorscale     == nil or UldRazorscale     == "--") then UldRazorscale     = 0; end;
  UldIgnis          = GetStatistic(2874); if (UldIgnis          == nil or UldIgnis          == "--") then UldIgnis          = 0; end;
  UldXT             = GetStatistic(2884); if (UldXT             == nil or UldXT             == "--") then UldXT             = 0; end;
  UldAssembly       = GetStatistic(2885); if (UldAssembly       == nil or UldAssembly       == "--") then UldAssembly       = 0; end;
  UldKologarn       = GetStatistic(2875); if (UldKologarn       == nil or UldKologarn       == "--") then UldKologarn       = 0; end;
  UldAuriaya        = GetStatistic(2882); if (UldAuriaya        == nil or UldAuriaya        == "--") then UldAuriaya        = 0; end;
  UldHodir          = GetStatistic(3256); if (UldHodir          == nil or UldHodir          == "--") then UldHodir          = 0; end;
  UldThorim         = GetStatistic(3257); if (UldThorim         == nil or UldThorim         == "--") then UldThorim         = 0; end;
  UldFreya          = GetStatistic(3258); if (UldFreya          == nil or UldFreya          == "--") then UldFreya          = 0; end;
  UldMimiron        = GetStatistic(2879); if (UldMimiron        == nil or UldMimiron        == "--") then UldMimiron        = 0; end;
  UldGeneralVezax   = GetStatistic(2880); if (UldGeneralVezax   == nil or UldGeneralVezax   == "--") then UldGeneralVezax   = 0; end;
  UldYoggSaron      = GetStatistic(2883); if (UldYoggSaron      == nil or UldYoggSaron      == "--") then UldYoggSaron      = 0; end;
  UldAlgalon        = GetStatistic(2881); if (UldAlgalon        == nil or UldAlgalon        == "--") then UldAlgalon        = 0; end;
  UldTotalKills     = UldFlameLeviathan + UldRazorscale + UldIgnis + UldXT + UldAssembly + UldKologarn + UldAuriaya + UldHodir + UldThorim + UldFreya + UldMimiron + UldGeneralVezax + UldYoggSaron + UldAlgalon;
end

function  BMR_GetCotCTotals()
  CotCBeasts        = 0 + tonumber(GetStatistic(4031));
  CotCLordJaraxxus  = 0 + tonumber(GetStatistic(4034));
  CotCFactionChamp  = 0 + tonumber(GetStatistic(4038));
  CotCValkyrTwins   = 0 + tonumber(GetStatistic(4042));
  CotCTimesComplete = 0 + tonumber(GetStatistic(4046));
  CotCTotalKills = 0 + CotCBeasts + CotCLordJaraxxus + CotCFactionChamp + CotCValkyrTwins + CotCTimesComplete;
end

function BMR_GetICCTotals()
  ICCLichKing       = 0 + ifnil(tonumber(GetStatistic(4687)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Lich King: " .. ICCLichKing);
  ICCSindragosa     = 0 + ifnil(tonumber(GetStatistic(4683)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Sindragosa: " .. ICCSindragosa);
  ICCBloodQueen     = 0 + ifnil(tonumber(GetStatistic(4681)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Blood Queen: " .. ICCBloodQueen);
  ICCPutricide      = 0 + ifnil(tonumber(GetStatistic(4678)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Putricide: " .. ICCPutricide);
  ICCValithria      = 0 + ifnil(tonumber(GetStatistic(4675)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Valithria: " .. ICCValithria);
  ICCBloodCouncil   = 0 + ifnil(tonumber(GetStatistic(4672)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Blood Council: " .. ICCBloodCouncil);
  ICCRotface        = 0 + ifnil(tonumber(GetStatistic(4669)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Rotface: " .. ICCRotface);
  ICCFestergut      = 0 + ifnil(tonumber(GetStatistic(4666)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Festergut: " .. ICCFestergut);
  ICCDeathbringer   = 0 + ifnil(tonumber(GetStatistic(4663)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Deathbringer: " .. ICCDeathbringer);
  ICCGunship        = 0 + ifnil(tonumber(GetStatistic(4660)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Gunship Battle: " .. ICCGunship);
  ICCDeathwhisper   = 0 + ifnil(tonumber(GetStatistic(4655)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Deathwhisper: " .. ICCDeathwhisper);
  ICCMarrowgar      = 0 + ifnil(tonumber(GetStatistic(4641)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Marrowgar: " .. ICCMarrowgar);
  ICCTotalKills     = 0 + ICCLichKing + ICCSindragosa + ICCBloodQueen + ICCPutricide + ICCValithria + ICCBloodCouncil + ICCRotface + ICCFestergut + ICCDeathbringer + ICCGunship + ICCDeathwhisper + ICCMarrowgar;
end

function BMR_GetTargetTotals()
  if (bCheckingTotals == 1) then
    bCheckingTotals = 0;
    if (UnitIsPlayer("target")) then
     
      local compUldFlameLeviathan, compUldRazorscale, compUldIgnis, compUldXT, compUldAssembly, compUldKologarn, compUldAuriaya, compUldHodir, compUldThorim, compUldFreya, compUldMimiron, compUldGeneralVezax, compUldYoggSaron, compUldAlgalon, compUldTotalKills;
      local compCotCBeasts, compCotCLordJaraxxus, compCotCFactionChamp, compCotCValkyrTwins, compCotCTimesComplete, compCotCTotalKills
      local compICCLichKing, compICCSindragosa, compICCBloodQueen, compICCPutricide, compICCValithria, compICCBloodCouncil, compICCRotface, compICCFestergut, compICCDeathbringer, compICCGunship, compICCDeathwhisper, compICCMarrowgar, compICCTotalKillsl;
      local compUldVeteran = "|cFFFF0000Not a Veteran";
      local compCotCVeteran = "|cFFFF0000Not a Veteran";
      local compICCVeteran = "|cFFFF0000Not a Veteran";
     
      compUldFlameLeviathan = 0 + ifnil(tonumber(GetComparisonStatistic(2872)), 0);
      compUldRazorscale     = 0 + ifnil(tonumber(GetComparisonStatistic(2873)), 0);
      compUldIgnis          = 0 + ifnil(tonumber(GetComparisonStatistic(2874)), 0);
      compUldXT             = 0 + ifnil(tonumber(GetComparisonStatistic(2884)), 0);
      compUldAssembly       = 0 + ifnil(tonumber(GetComparisonStatistic(2885)), 0);
      compUldKologarn       = 0 + ifnil(tonumber(GetComparisonStatistic(2875)), 0);
      compUldAuriaya        = 0 + ifnil(tonumber(GetComparisonStatistic(2882)), 0);
      compUldHodir          = 0 + ifnil(tonumber(GetComparisonStatistic(3256)), 0);
      compUldThorim         = 0 + ifnil(tonumber(GetComparisonStatistic(3257)), 0);
      compUldFreya          = 0 + ifnil(tonumber(GetComparisonStatistic(3258)), 0);
      compUldMimiron        = 0 + ifnil(tonumber(GetComparisonStatistic(2879)), 0);
      compUldGeneralVezax   = 0 + ifnil(tonumber(GetComparisonStatistic(2880)), 0);
      compUldYoggSaron      = 0 + ifnil(tonumber(GetComparisonStatistic(2883)), 0);
      compUldAlgalon        = 0 + ifnil(tonumber(GetComparisonStatistic(2881)), 0);
      compUldTotalKills     = 0 + compUldFlameLeviathan + compUldRazorscale + compUldIgnis + compUldXT + compUldAssembly + compUldKologarn + compUldAuriaya + compUldHodir + compUldThorim + compUldFreya + compUldMimiron + compUldGeneralVezax + compUldYoggSaron + compUldAlgalon;
      if(compUldTotalKills >= 110) then
        compUldVeteran = "|cFF00FF00Veteran"
      end; 
   
      compCotCBeasts        = 0 + ifnil(tonumber(GetComparisonStatistic(4031)), 0);
      compCotCLordJaraxxus  = 0 + ifnil(tonumber(GetComparisonStatistic(4034)), 0);
      compCotCFactionChamp  = 0 + ifnil(tonumber(GetComparisonStatistic(4038)), 0);
      compCotCValkyrTwins   = 0 + ifnil(tonumber(GetComparisonStatistic(4042)), 0);
      compCotCTimesComplete = 0 + ifnil(tonumber(GetComparisonStatistic(4046)), 0);
      compCotCTotalKills = 0 + compCotCBeasts + compCotCLordJaraxxus + compCotCFactionChamp + compCotCValkyrTwins + compCotCTimesComplete;
      if(compCotCTotalKills >= 35) then
        compCotCVeteran = "|cFF00FF00Veteran"
      end;
    
      compICCLichKing     = 0 + ifnil(tonumber(GetComparisonStatistic(4687)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Lich King: " .. ICCLichKing);
      compICCSindragosa   = 0 + ifnil(tonumber(GetComparisonStatistic(4683)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Sindragosa: " .. ICCSindragosa);
      compICCBloodQueen   = 0 + ifnil(tonumber(GetComparisonStatistic(4681)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Blood Queen: " .. ICCBloodQueen);
      compICCPutricide    = 0 + ifnil(tonumber(GetComparisonStatistic(4678)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Putricide: " .. ICCPutricide);
      compICCValithria    = 0 + ifnil(tonumber(GetComparisonStatistic(4675)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Valithria: " .. ICCValithria);
      compICCBloodCouncil = 0 + ifnil(tonumber(GetComparisonStatistic(4672)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Blood Council: " .. ICCBloodCouncil);
      compICCRotface      = 0 + ifnil(tonumber(GetComparisonStatistic(4669)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Rotface: " .. ICCRotface);
      compICCFestergut    = 0 + ifnil(tonumber(GetComparisonStatistic(4666)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Festergut: " .. ICCFestergut);
      compICCDeathbringer = 0 + ifnil(tonumber(GetComparisonStatistic(4663)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Deathbringer: " .. ICCDeathbringer);
      compICCGunship      = 0 + ifnil(tonumber(GetComparisonStatistic(4660)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Gunship Battle: " .. ICCGunship);
      compICCDeathwhisper = 0 + ifnil(tonumber(GetComparisonStatistic(4655)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Deathwhisper: " .. ICCDeathwhisper);
      compICCMarrowgar    = 0 + ifnil(tonumber(GetComparisonStatistic(4641)), 0); --DEFAULT_CHAT_FRAME:AddMessage("Marrowgar: " .. ICCMarrowgar);
      compICCTotalKills   = 0 + compICCLichKing + compICCSindragosa + compICCBloodQueen + compICCPutricide + compICCValithria + compICCBloodCouncil + compICCRotface + compICCFestergut + compICCDeathbringer + compICCGunship + compICCDeathwhisper + compICCMarrowgar;

      if(compICCTotalKills >= 100) then
        compICCVeteran = "|cFF00FF00Veteran"
      end;
      DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..UnitName("target") .. " Veteran Status:");
      DEFAULT_CHAT_FRAME:AddMessage("Ulduar Status: " .. compUldVeteran .. "(" .. compUldTotalKills .. " kills)");
      DEFAULT_CHAT_FRAME:AddMessage("Trials of the Crusader: " .. compCotCVeteran .. "(" .. compCotCTotalKills .. " kills)");
      DEFAULT_CHAT_FRAME:AddMessage("Fall of the Lich King: " .. compICCVeteran .. "(" .. compICCTotalKills .. " kills)");
    end;
    ClearAchievementComparisonUnit();
  end;
end

function BMR_IsMasterLooter()
  lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod();
  if(lootmethod == "master") then
    if ( masterlooterPartyID == 0 ) then
      return true;
    else
      return false;
    end
  else
    if(IsInRaid()) then
      isLeader = UnitIsGroupLeader("player");
      if (isLeader) then
        return true;
      else
        return false;
      end
    end
  end
end

function BMR_ChatEdit_InsertLink(text)
	if ( not text ) then
		return false;
	end
  if (BMRItemEdit:IsVisible()) then
    BMRItemEdit:SetMaxBytes(strlen(text)+100);
    BMRItemEdit:SetText(text);
    --BMRItemEdit:HighlightText(0, 1);
    return false;
  end
end

function VersionCheck()
 DEFAULT_CHAT_FRAME:AddMessage("BadMoonRoller: Your Version: " .. BMR_VERSION);
 DEFAULT_CHAT_FRAME:AddMessage("--------------------------------------");
 local playerName = UnitName("player");
 SendAddonMessage("BMRoller", "VERSION_QUERY " .. playerName, "RAID"); 
end

function BMR_OnLoad()
  --Replace the current ChatEdit_InsertLink functionality to catch it
  Old_ChatEdit_InsertLink = ChatEdit_InsertLink;
  ChatEdit_InsertLink = function(text)
    return BMR_ChatEdit_InsertLink(text) or Old_ChatEdit_InsertLink(text)
  end;
  
  bmrRolls = {};
  bmrRollers = {};
	tinsert(UISpecialFrames,"BadMoonRollingForm");
  DEFAULT_CHAT_FRAME:AddMessage("BadMoonRoller: Loaded and Ready")

  SLASH_BMR1 = "/badmoonrolling";
  SLASH_BMR2 = "/bmr";
  SlashCmdList["BMR"] = function(msg)
		BMR_SlashCommandHandler(msg);
	end
	BadMoonRollingForm:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	BadMoonRollingForm:RegisterEvent("CHAT_MSG_SYSTEM");
	BadMoonRollingForm:RegisterEvent("CHAT_MSG_ADDON");
	BadMoonRollingForm:RegisterEvent("ADDON_LOADED");
	BadMoonRollingForm:RegisterEvent("PLAYER_LOGOUT");
	BadMoonRollingForm:RegisterEvent("INSPECT_ACHIEVEMENT_READY");

  RegisterAddonMessagePrefix("BMRoller");

end
function BMR_SlashCommandHandler(msg)
	if (msg == "rl") then
	 ReloadUI();
	elseif (msg == "versioncheck" or msg == "v") then
	 VersionCheck();
	elseif (msg == "killcount") then
	 BMR_GetTargetKillCount();
	else
	  BMR_Toggle();
	end
end
function BMR_Toggle(inHideShow)
  if (inHideShow == nil) then
    inHideShow = 2;
  end
  local frame = getglobal("BadMoonRollingForm");
  local isLeader = BMR_IsMasterLooter();
  if (frame) then
    if((frame:IsVisible() and inHideShow == 2) or inHideShow == 0) then
      frame:Hide();
      BadMoonRollListFrame:Hide();
      BadMoonRollItemFrame:Hide();
    else
      frame:Show();
      if (ShowingRollList == 1) then
        BadMoonRollListFrame:Show();
      end
      if(isLeader) then
        BadMoonRollItemFrame:Show();
      end
    end
  end
end
function HideRolls()
  BadMoonRollListFrame:Hide();
  BadMoonRollItemFrame:Hide();
end
function BMR_ListToggle()
  local frame = getglobal("BadMoonRollListFrame")
  if (frame) then
    if(  frame:IsVisible() ) then
      frame:Hide();
      ShowingRollList = 0;
      BMRBtnRollerShowList:SetText(">");
    else
      frame:Show();
      ShowingRollList = 1;
      BMRBtnRollerShowList:SetText("<");
    end
  end
end
function BMR_EventHandler(frame, event, arg1, ...)
  if (event == "CHAT_MSG_SYSTEM") then
    HandleChat(arg1);
  elseif (event == "CHAT_MSG_ADDON" ) then
  		BMR_CHAT_MSG_ADDON(arg1, ...);
  elseif (event == "ADDON_LOADED") then
    if (AnnounceChecked == nil) then
      AnnounceChecked = 1;
    end
    BMRRollingAnnounce:SetChecked((AnnounceChecked == 1));
  elseif event == "PLAYER_LOGOUT" then
    if (BMRRollingAnnounce:GetChecked()) then
      AnnounceChecked = 1;
    else
      AnnounceChecked = 0;
    end
  elseif event == "INSPECT_ACHIEVEMENT_READY" then
    BMR_GetTargetTotals();
  end
end

function BMR_CHAT_MSG_ADDON(...)
  local arg1, arg2 = ...;
  if (arg1 == "BMRoller") then
    if(arg2 and strsub(arg2, 1, 13) == "VERSION_QUERY") then
      local playerName = UnitName("player");
      SendAddonMessage("BMRoller", "VERSION_RESPONSE " .. playerName .. " - " .. BMR_VERSION, "WHISPER", strsub(arg2, 15)); 
    elseif (arg2 and strsub(arg2, 1, 16) == "VERSION_RESPONSE") then
      DEFAULT_CHAT_FRAME:AddMessage(strsub(arg2, 17));
    else
      local frame = _G["BadMoonRollListFrame"];
      if (frame) then
        if( not frame:IsVisible() ) then
          BMR_Toggle(1);
        end
      end
      BadMoonRollListFrameLabel:SetText(strsub(arg2, 1, 11));
      BadMoonRollListFrameItemLabel:SetText(strsub(arg2, 11));
      BMR_ClearList();
    end;
  end
end


function HandleChat(string)
	for char, roll, low, high in string.gmatch(string, "([^%s]+) rolls (%d+) %((%d+)%-(%d+)%)$") do
    if (bmrRollers[char]) then
      bmrRollers[char] = bmrRollers[char] + 1;
    else
      bmrRollers[char] = 1;
    end
    local rollnumber = " ";
    if(bmrRollers[char] > 1) then
      rollnumber = "(" .. bmrRollers[char] .. ") ";
    else
      rollnumber = " ";
    end
    table.insert(bmrRolls, {Char=char, Roll=tonumber(roll), Low=tonumber(low), High=tonumber(high), ReRoll=rollnumber});
  end
  UpdateRollList();  
end
function UpdateRollList()
  local rollText = "";
  table.sort(bmrRolls, function(a,b) return a.Roll > b.Roll end);
  timesShown = 1;
  local colorcode;
  for i, row in pairs(bmrRolls) do
    if (row.Low == 1 and row.High == 25) then
      colorcode = "|cffffffff";
    elseif (row.Low == 26 and row.High ==  50) then
      colorcode = "|cff1eff00";
    elseif (row.Low == 51 and row.High ==  75) then
      colorcode = "|cff0070dd";
    elseif (row.Low == 76 and row.High == 100) then
      colorcode = "|cffa335ee";
    elseif (row.Low == 101 and row.High == 125) then
      colorcode = "|cffff8000";
    else
      colorcode = "|cff9d9d9d";
    end;
    timesShown = timesShown + 1;
    if (rollText) then
      rollText = rollText .. "\n" .. colorcode .. row.Roll .. ": " .. row.Char .. row.ReRoll .. "(" .. row.Low .. "-" .. row.High .. ")";
    else
      rollText = colorcode .. row.Roll .. ": " .. row.Char .. row.ReRoll .. "(" .. row.Low .. "-" .. row.High .. ")";
    end
  end
  local maxValue = ((timesShown) * 12) - 190;
  if (maxValue < 0) then
    ScrollFrameTest_VSlider:Hide();
    maxValue = 0;
  else
    ScrollFrameTest_VSlider:Show();
  end
  RollListText:SetText(rollText);
  ScrollFrameTest_VSlider:SetMinMaxValues(0, maxValue);
end

function BMR_RollPass()
end;
function BMR_RollRP()
  RandomRoll(1, 25);
end
function BMR_RollOffSpec()
  RandomRoll(26, 50);
end
function BMR_RollWant()
  RandomRoll(51, 75);
end
function BMR_RollNeed()
  RandomRoll(76, 100);
end
function BMR_RollVeteran()
  RandomRoll(101, 125);
end
function BMR_ToolTip(inButton)
  GameTooltip:SetOwner(BadMoonRollingForm, ANCHOR_CURSOR);
  GameTooltip:ClearLines();
  if (inButton == "Pass") then
    GameTooltip:AddLine("Pass", .75, .75, .25);
    GameTooltip:AddLine("You do not want the item.", 1, 1, 1);
  elseif (inButton == "RP") then
    GameTooltip:AddLine("RP", .75, .75, .25);
    GameTooltip:AddLine("For appearance uses.", 1, 1, 1);
    GameTooltip:AddLine("Rolls 1-25", 1, 1, 1);
  elseif (inButton == "OFFSPEC") then
    GameTooltip:AddLine("Off-Spec/Sidegrades/Alt Character", .75, .75, .25);
    GameTooltip:AddLine("For Secondary Roles, Sidegrades,", 1, 1, 1);
    GameTooltip:AddLine("and Alternative Character", 1, 1, 1);
    GameTooltip:AddLine("Rolls 26-50", 1, 1, 1);
  elseif (inButton == "WANT") then
    GameTooltip:AddLine("Want Roll", .75, .75, .25);
    GameTooltip:AddLine("For Main Spec", 1, 1, 1);
    GameTooltip:AddLine("Rolls 51-75", 1, 1, 1);
  elseif (inButton == "NEED") then
    GameTooltip:AddLine("Need Roll", .75, .75, .25);
    GameTooltip:AddLine("For Main Spec", 1, 1, 1);
    GameTooltip:AddLine("Allowed one WIN per raid.", 1, 1, 1);
    GameTooltip:AddLine("Rolls 76-100", 1, 1, 1);
  elseif (inButton == "VETERAN") then
    GameTooltip:AddLine("Veteran Roll", .75, .75, .25);
    GameTooltip:AddLine("For Main Spec", 1, 1, 1);
    GameTooltip:AddLine("Allowed one WIN per raid.", 1, 1, 1);
    GameTooltip:AddLine("Rolls 101-125", 1, 1, 1);
  elseif (inButton == "STANDARD") then  
    GameTooltip:AddLine("Standard Roll (1-100)", .75, .75, .25);
    GameTooltip:AddLine("For Regular 1 to 100 rolls", 1, 1, 1);
    GameTooltip:AddLine("Rolls 1-100", 1, 1, 1);
  end
  GameTooltip:Show();
end
function BMR_CloseToolTip()
  GameTooltip:Hide();
end
function BMR_ClearList()
  local rollText = "";
  RollListText:SetText(rollText);
  ScrollFrameTest_VSlider:SetMinMaxValues(0, 0);
  ScrollFrameTest_VSlider:Hide();
  timesShown = 0;
  bmrRolls = {};
  bmrRollers = {};
end

function BMR_StartRolling()
  local rollitem = BMRItemEdit:GetText();
  if(strlen(rollitem) == 0) then
    return;
  end

  isChecked = BMRRollingAnnounce:GetChecked();
  if (isChecked) then
    if (UnitInRaid("player")) then
      SendChatMessage("Rolling On: " .. rollitem, "RAID_WARNING", nil, nil);
      SendAddonMessage("BMRoller", "Rolls for: " .. rollitem, "RAID");
    elseif (IsPartyLeader()) then
      SendChatMessage("Rolling On: " .. rollitem, "PARTY", nil, nil);
      SendAddonMessage("BMRoller", "Rolls for: " .. rollitem, "PARTY");
    end
  end
end

function BMR_GetTargetKillCount()
  ClearAchievementComparisonUnit();  
  bCheckingTotals = SetAchievementComparisonUnit("target");
end